"use strict";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FormFieldSkin = FormFieldSkin;

var _react = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _PopOver = require("../../components/PopOver");

var _SimpleFormField = require("../../themes/simple/SimpleFormField");

var _hooks = require("../../utils/hooks");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function FormFieldSkin(props) {
  var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      isFormFieldFocused = _useState2[0],
      setIsFormFieldFocused = _useState2[1];

  var setFormFieldRef = (0, _hooks.handleRefFocusState)(props.formFieldRef, setIsFormFieldFocused);
  var hasError = props.error != null;
  return (
    /*#__PURE__*/
    _react["default"].createElement("div", {
      className: (0, _classnames["default"])([props.className, props.theme[props.themeId].root, props.disabled ? props.theme[props.themeId].disabled : null, props.error ? props.theme[props.themeId].errored : null])
    }, props.label &&
    /*#__PURE__*/
    _react["default"].createElement("label", {
      role: "presentation",
      "aria-hidden": true,
      className: props.theme[props.themeId].label,
      onClick: props.focusChild
    }, props.label),
    /*#__PURE__*/
    _react["default"].createElement(_PopOver.PopOver, {
      visible: props.isErrorShown || hasError && isFormFieldFocused && !props.isErrorHidden,
      content: props.error,
      themeVariables: {
        '--rp-pop-over-bg-color': "var(".concat(_SimpleFormField.SimpleFormFieldVariables.errorColor)
      },
      placement: "bottom",
      popperOptions: {
        modifiers: [{
          name: 'flip',
          enabled: false
        }]
      },
      duration: [300, 0]
    },
    /*#__PURE__*/
    _react["default"].createElement("div", {
      className: props.theme[props.themeId].inputWrapper
    }, props.render(setFormFieldRef))))
  );
}
//# sourceMappingURL=FormFieldSkin.js.map