"use strict";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PasswordInputSkin = void 0;

var _classnames = _interopRequireDefault(require("classnames"));

var _react = _interopRequireWildcard(require("react"));

var _Input = require("../../components/Input");

var _PasswordInput = require("../../components/PasswordInput");

var _PopOver = require("../../components/PopOver");

var _SimplePasswordInput = require("../../themes/simple/SimplePasswordInput");

var _hooks = require("../../utils/hooks");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function getPopOverBgColorForState(state) {
  switch (state) {
    case _PasswordInput.PasswordInput.STATE.ERROR:
    case _PasswordInput.PasswordInput.STATE.INSECURE:
      return "var(".concat(_SimplePasswordInput.SimplePasswordInputVariables.errorColor, ")");

    case _PasswordInput.PasswordInput.STATE.WEAK:
      return "var(".concat(_SimplePasswordInput.SimplePasswordInputVariables.warningColor, ")");

    case _PasswordInput.PasswordInput.STATE.STRONG:
      return "var(".concat(_SimplePasswordInput.SimplePasswordInputVariables.successColor, ")");

    case _PasswordInput.PasswordInput.STATE.DEFAULT:
    default:
      return 'var(--rp-pop-over-bg-color)';
  }
}

var PasswordInputSkin = function PasswordInputSkin(props) {
  var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      hasInputFocus = _useState2[0],
      setHasInputFocus = _useState2[1];

  var _useState3 = (0, _react.useState)(false),
      _useState4 = _slicedToArray(_useState3, 2),
      isInputHovered = _useState4[0],
      setIsInputHovered = _useState4[1];

  var className = props.className,
      error = props.error,
      debounceDelay = props.debounceDelay,
      isShowingTooltipOnFocus = props.isShowingTooltipOnFocus,
      isShowingTooltipOnHover = props.isShowingTooltipOnHover,
      isTooltipOpen = props.isTooltipOpen,
      score = props.score,
      state = props.state,
      theme = props.theme,
      themeId = props.themeId,
      tooltip = props.tooltip,
      useDebounce = props.useDebounce,
      value = props.value,
      inputProps = _objectWithoutProperties(props, ["className", "error", "debounceDelay", "isShowingTooltipOnFocus", "isShowingTooltipOnHover", "isTooltipOpen", "score", "state", "theme", "themeId", "tooltip", "useDebounce", "value"]);

  var hasInitialValueChanged = useDebounce ? (0, _hooks.useDebouncedValueChangedIndicator)(value, debounceDelay) : true;
  var hasTooltip = hasInitialValueChanged && tooltip != null;
  return (
    /*#__PURE__*/
    _react["default"].createElement("div", {
      className: (0, _classnames["default"])([theme[themeId].root, theme[themeId][state], className])
    },
    /*#__PURE__*/
    _react["default"].createElement(_PopOver.PopOver, {
      visible: hasTooltip && (isTooltipOpen || isShowingTooltipOnHover && isInputHovered || isShowingTooltipOnFocus && hasInputFocus),
      content: tooltip,
      themeVariables: {
        '--rp-pop-over-bg-color': getPopOverBgColorForState(state)
      },
      placement: "bottom",
      popperOptions: {
        modifiers: [{
          name: 'flip',
          enabled: false
        }]
      },
      duration: [300, 0]
    },
    /*#__PURE__*/
    _react["default"].createElement(_Input.Input, _extends({}, inputProps, {
      showErrorState: hasInitialValueChanged && state === _PasswordInput.PasswordInput.STATE.ERROR,
      value: value,
      type: "password",
      onBlur: function onBlur() {
        return setHasInputFocus(false);
      },
      onFocus: function onFocus() {
        return setHasInputFocus(true);
      },
      onMouseEnter: function onMouseEnter() {
        return setIsInputHovered(true);
      },
      onMouseOut: function onMouseOut() {
        return setIsInputHovered(false);
      }
    }))),
    /*#__PURE__*/
    _react["default"].createElement("div", {
      className: theme[themeId].indicator
    },
    /*#__PURE__*/
    _react["default"].createElement("div", {
      className: theme[themeId].score,
      style: {
        width: "".concat((score || 0) * 100, "%")
      }
    })))
  );
}; // Static Properties


exports.PasswordInputSkin = PasswordInputSkin;
PasswordInputSkin.displayName = 'PasswordInputSkin';
//# sourceMappingURL=PasswordInputSkin.js.map